Debian Bug report logs - #675836
pmacct: FTBFS[!linux]: error: dereferencing pointer to incomplete type

version graph

Package: src:pmacct; Maintainer for src:pmacct is Jamie Wilkinson <jaq@debian.org>;

Reported by: debian-bsd@lists.debian.org

Date: Sun, 3 Jun 2012 16:09:02 UTC

Severity: serious

Tags: patch, sid, wheezy

Found in version pmacct/0.14.0-1

Fixed in version pmacct/0.14.0-1.1

Done: Nicholas Bamber <nicholas@periapt.co.uk>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-bsd@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Sun, 03 Jun 2012 16:09:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to debian-bsd@lists.debian.org:
New Bug report received and forwarded. Copy sent to debian-bsd@lists.debian.org, Jamie Wilkinson <jaq@debian.org>. (Sun, 03 Jun 2012 16:09:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Christoph Egger <christoph@debian.org>
To: submit@bugs.debian.org
Subject: pmacct: FTBFS[!linux]: error: dereferencing pointer to incomplete type
Date: Sun, 03 Jun 2012 18:07:38 +0200
Package: src:pmacct
Version: 0.14.0-1
Severity: serious
Tags: sid wheezy
User: debian-bsd@lists.debian.org
Usertags: kfreebsd
X-Debbugs-Cc: debian-bsd@lists.debian.org
Justification: fails to build from source (but built successfully in the past)

Hi!

Your package failed to build on the kfreebsd-* buildds:

gcc -DPACKAGE=\"pmacctd\" -DVERSION=\"0.14.0\" -DPROGNAME=1 -DIM_LITTLE_ENDIAN=1 -DHAVE_L2=1 -DHAVE_INET_PTON=1 -DHAVE_INET_NTOP=1 -DENABLE_IPV6=1 -DHAVE_PCAP_H=1 -DHAVE_LIBPCAP=1 -DPCAP_7=1 -DPCAP_TYPE_bpf=1 -DHAVE_LIBMYSQLCLIENT=1 -DWITH_MYSQL=1 -DWITH_PGSQL=1 -DHAVE_LIBSQLITE3=1 -DWITH_SQLITE3=1 -DHAVE_DLOPEN=1 -DSTDC_HEADERS=1 -DHAVE_SYS_WAIT_H=1 -DHAVE_GETOPT_H=1 -DHAVE_SYS_SELECT_H=1 -DHAVE_SYS_TIME_H=1 -DHAVE_U_INT64_T=1 -DHAVE_U_INT32_T=1 -DHAVE_U_INT16_T=1 -DHAVE_U_INT8_T=1 -DHAVE_64BIT_COUNTERS=1 -DENABLE_THREADS=1 -DRETSIGTYPE=void -DHAVE_VSNPRINTF=1  -I. -I.. -O2 -Wall -g -O2  -I/usr/include/postgresql   -c -o sockunion.o sockunion.c
sockunion.c: In function 'sockunion_print':
sockunion.c:628:26: error: dereferencing pointer to incomplete type
In file included from sockunion.c:25:0:
sockunion.c: At top level:
isis.h:41:31: warning: '_isis_devices' defined but not used [-Wunused-variable]
make[3]: *** [sockunion.o] Error 1

Full build log at
https://buildd.debian.org/status/fetch.php?pkg=pmacct&arch=kfreebsd-amd64&ver=0.14.0-1&stamp=1337846537

Regards

    Christoph

If you have further questions please mail debian-bsd@lists.debian.org

-- 
9FED 5C6C E206 B70A 5857  70CA 9655 22B9 D49A E731
Debian Developer | Lisp Hacker | CaCert Assurer




Added indication that bug 675836 blocks 671115 Request was from Nicholas Bamber <nicholas@periapt.co.uk> to control@bugs.debian.org. (Sun, 03 Jun 2012 21:33:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#675836; Package src:pmacct. (Mon, 04 Jun 2012 01:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jamie Wilkinson <jaq@debian.org>:
Extra info received and forwarded to list. (Mon, 04 Jun 2012 01:27:03 GMT) Full text and rfc822 format available.

Message #12 received at 675836@bugs.debian.org (full text, mbox):

From: Jamie Wilkinson <jaq@debian.org>
To: 675836@bugs.debian.org
Cc: Nicholas Bamber <nicholas@periapt.co.uk>
Subject: Re: Processed: blocker
Date: Mon, 4 Jun 2012 11:24:37 +1000
[Message part 1 (text/plain, inline)]
I don't understand, how is this ftbfs blocking the mysql transition?   I
can't read your mind; please try to overcommunicate in your bug updates in
the future.

On 4 June 2012 07:33, Debian Bug Tracking System <owner@bugs.debian.org>wrote:

> Processing commands for control@bugs.debian.org:
>
> > block 671115 by 675836
> Bug #671115 [release.debian.org] transition: mysql-5.5
> 671115 was blocked by: 674328 673528 667428 673263 650058 660686 674122
> 649955 651110 674309 672714 650060 666331 672619 672950 672716 673264
> 651317 674210 673262 640818 672765 661422 673260 673183 673161 649638
> 668232 673153 672824 672621 672816 672207 672588
> 671115 was blocking: 672928
> Added blocking bug(s) of 671115: 675836
> >
> End of message, stopping processing here.
>
> Please contact me if you need assistance.
> --
> 671115: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=671115
> Debian Bug Tracking System
> Contact owner@bugs.debian.org with problems
>
[Message part 2 (text/html, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Mon, 04 Jun 2012 06:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Mon, 04 Jun 2012 06:06:03 GMT) Full text and rfc822 format available.

Message #17 received at 675836@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: Jamie Wilkinson <jaq@debian.org>
Cc: 675836@bugs.debian.org
Subject: Re: Processed: blocker
Date: Mon, 04 Jun 2012 07:02:43 +0100
Jamie,
	It simply means that it has not built against the new mysql on all 
archirectures  yet. It does not imply that it is mysql related.

On 04/06/12 02:24, Jamie Wilkinson wrote:
> I don't understand, how is this ftbfs blocking the mysql transition?   I
> can't read your mind; please try to overcommunicate in your bug updates
> in the future.
>
> On 4 June 2012 07:33, Debian Bug Tracking System <owner@bugs.debian.org
> <mailto:owner@bugs.debian.org>> wrote:
>
>     Processing commands for control@bugs.debian.org
>     <mailto:control@bugs.debian.org>:
>
>      > block 671115 by 675836
>     Bug #671115 [release.debian.org <http://release.debian.org>]
>     transition: mysql-5.5
>     671115 was blocked by: 674328 673528 667428 673263 650058 660686
>     674122 649955 651110 674309 672714 650060 666331 672619 672950
>     672716 673264 651317 674210 673262 640818 672765 661422 673260
>     673183 673161 649638 668232 673153 672824 672621 672816 672207 672588
>     671115 was blocking: 672928
>     Added blocking bug(s) of 671115: 675836
>      >
>     End of message, stopping processing here.
>
>     Please contact me if you need assistance.
>     --
>     671115: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=671115
>     Debian Bug Tracking System
>     Contact owner@bugs.debian.org <mailto:owner@bugs.debian.org> with
>     problems
>
>





Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 11:01:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 11:01:06 GMT) Full text and rfc822 format available.

Message #22 received at 675836@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: Jamie Wilkinson <jaq@debian.org>
Cc: 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org
Subject: suggested fix
Date: Wed, 20 Jun 2012 11:56:43 +0100
[Message part 1 (text/plain, inline)]
Jamie,

I have a proposed  fix as attached. It's built, signed and ready to go.
If you have intentions to fix it yourself please reply and do so
promptly. I'll run my fix past a few people for feedback but after that
I'll upload with a 2-day delay.
[pmacct.debdiff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 11:03:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 11:03:23 GMT) Full text and rfc822 format available.

Message #27 received at 675836@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: Nicholas Bamber <nicholas@periapt.co.uk>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org
Subject: Re: suggested fix
Date: Wed, 20 Jun 2012 12:00:33 +0100
[Message part 1 (text/plain, inline)]
On 20/06/12 11:56, Nicholas Bamber wrote:
> Jamie,
> 
> I have a proposed  fix as attached. It's built, signed and ready to go.
> If you have intentions to fix it yourself please reply and do so
> promptly. I'll run my fix past a few people for feedback but after that
> I'll upload with a 2-day delay.

Hmm, it seems I got the debdiff the wrong way round. Resent.
[pmacct.debdiff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 12:57:16 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 12:57:23 GMT) Full text and rfc822 format available.

Message #32 received at 675836@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Wed, 20 Jun 2012 12:53:51 +0100
On 20/06/12 12:27, Steven Chamberlain wrote:
> On 20/06/12 11:56, Nicholas Bamber wrote:
>> I have a proposed  fix as attached. It's built, signed and ready to go.
>> If you have intentions to fix it yourself please reply and do so
>> promptly. I'll run my fix past a few people for feedback but after that
>> I'll upload with a 2-day delay.
> 
> Thanks for this.  It looks okay and seems it would fix the FTBFS.
> 
> However... I'm wondering if a more generic test could be used instead of
> FreeBSD || FreeBSD_kernel.  Other BSD's would need this header too for
> the sockaddr_dl definition[1].  And it looks like GNU/Hurd was failing
> on this same code so it possibly has (or should have) the same.
> 
> [1] http://fxr.watson.org/fxr/trackident?v=FREEBSD9;i=sockaddr_dl
> [2]
> https://buildd.debian.org/status/fetch.php?pkg=pmacct&arch=hurd-i386&ver=0.14.0-1&stamp=1339115492
> 
> What about using AF_LINK as a test of whether to include this header?
> It looks to me like it would work.
> 
> This way we'd be helping out GNU/Hurd at the same time, the fix would be
> more appropriate for upstream and it helps with future portability.
> 
> Thanks again,
> Regards,

Steven,
	Sorry I didn't notice the FTBS on hurd as I was concentrating on the
red. I guess I should have trusted the bug report title more.

However I am confused at what your are proposing. For a start I cannot
find a net/if_dl.h file on Hurd. Secondly I am not clear if using
AF_LINK as a conditional is a good idea. Surely that would change the
code on Linux, which is surely not what we want to do. Also googling for
Hurd and  sockaddr_dl has not so far turned up anything useful. What
bugs such as #636510 and #256669 do suggest is that AF_LINK is a bad
indicator of the presence of sockaddr_dl. Maybe the solution is to
furher guard the #ifdef AF_LINK bits by requiring that the OS not be Hurd.






Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 13:03:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 13:03:13 GMT) Full text and rfc822 format available.

Message #37 received at 675836@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Nicholas Bamber <nicholas@periapt.co.uk>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org
Subject: Re: suggested fix
Date: Wed, 20 Jun 2012 12:27:09 +0100
On 20/06/12 11:56, Nicholas Bamber wrote:
> I have a proposed  fix as attached. It's built, signed and ready to go.
> If you have intentions to fix it yourself please reply and do so
> promptly. I'll run my fix past a few people for feedback but after that
> I'll upload with a 2-day delay.

Thanks for this.  It looks okay and seems it would fix the FTBFS.

However... I'm wondering if a more generic test could be used instead of
FreeBSD || FreeBSD_kernel.  Other BSD's would need this header too for
the sockaddr_dl definition[1].  And it looks like GNU/Hurd was failing
on this same code so it possibly has (or should have) the same.

[1] http://fxr.watson.org/fxr/trackident?v=FREEBSD9;i=sockaddr_dl
[2]
https://buildd.debian.org/status/fetch.php?pkg=pmacct&arch=hurd-i386&ver=0.14.0-1&stamp=1339115492

What about using AF_LINK as a test of whether to include this header?
It looks to me like it would work.

This way we'd be helping out GNU/Hurd at the same time, the fix would be
more appropriate for upstream and it helps with future portability.

Thanks again,
Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 13:03:21 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 13:03:29 GMT) Full text and rfc822 format available.

Message #42 received at 675836@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Nicholas Bamber <nicholas@periapt.co.uk>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Wed, 20 Jun 2012 13:26:23 +0100
Hi Nicholas,

On 20/06/12 12:53, Nicholas Bamber wrote:
> Sorry I didn't notice the FTBS on hurd as I was concentrating on the
> red. I guess I should have trusted the bug report title more.

I only noticed on buildd.d.o that the failure was the same there.

> However I am confused at what your are proposing.

If you're not convinced, then the patch you have is fine.  It would fix
the immediate FTBFS on kfreebsd-* and this could be revisited later.

I was only trying to kill two (or more) birds with one stone here, by
accommodating GNU/Hurd, and keeping portability to some other future
k*BSD port, and if the patch is forwarded upstream they might like it to
fix this on other arches they support.

> For a start I cannot
> find a net/if_dl.h file on Hurd.

I'm not sure...  be warned that packages.d.o might not be indexing
package contents for GNU/Hurd.  (At least once before this has caught me
out).

For the Hurd, I thought, if the header inclusion test was AF_LINK:

1. if it supports sockaddr_dl, and has net/if_dl.h, it would be fixed

2. if it supports sockaddr_dl, but currently lacks net/if_dl.h, the new
build error would make the problem clearer, and it could build in future
without changes after they provide the missing net/if_dl.h

3. if it doesn't support sockaddr_dl, the AF_LINK test is wrong in
_both_ places so it wouldn't be able to build anyway;  we'd be no worse-off.

> Secondly I am not clear if using
> AF_LINK as a conditional is a good idea. Surely that would change the
> code on Linux, which is surely not what we want to do.

I was assuming that platforms without sockaddr_dl don't define AF_LINK.
 I don't see it in the Linux headers.

And the FXR pages also showed a correlation between AF_LINK being
defined on a platform, and the existence of a net/if_dl.h containing the
definition of sockaddr_dl.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 15:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 15:03:03 GMT) Full text and rfc822 format available.

Message #47 received at 675836@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: Jamie Wilkinson <jaq@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Wed, 20 Jun 2012 15:59:47 +0100
[Message part 1 (text/plain, inline)]
Jamie,
	Based upon the feedback I have received (including #debian-hurd) I am
attaching a new debdiff. Unless I get any more feedback I'll probably
upload it tomorrow with a 2-day delay.
[pmacct.debdiff (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 21:14:24 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 21:17:20 GMT) Full text and rfc822 format available.

Message #52 received at 675836@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Nicholas Bamber <nicholas@periapt.co.uk>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Wed, 20 Jun 2012 22:04:07 +0100
On 20/06/12 15:59, Nicholas Bamber wrote:
> Based upon the feedback I have received (including #debian-hurd) I am
> attaching a new debdiff.

This debdiff doesn't address the main point of my original mail:
sockaddr_dl and net/if_dl.h are not (k)FreeBSD-specific, so a test for
FreeBSD || FreeBSD_kernel would not be appropriate.  It might "work" but
would only replace one portability issue with another.

The new test for AF_LINK && !GNU looks even worse to me.  Does GNU/Hurd
_really_ define AF_LINK and yet not provide a net/if_dl.h with a
definition for sockaddr_dl?

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 21:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 21:39:03 GMT) Full text and rfc822 format available.

Message #57 received at 675836@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Wed, 20 Jun 2012 22:09:23 +0100
On 20/06/12 22:04, Steven Chamberlain wrote:
> On 20/06/12 15:59, Nicholas Bamber wrote:
>> Based upon the feedback I have received (including #debian-hurd) I am
>> attaching a new debdiff.
> 
> This debdiff doesn't address the main point of my original mail:
> sockaddr_dl and net/if_dl.h are not (k)FreeBSD-specific, so a test for
> FreeBSD || FreeBSD_kernel would not be appropriate.  It might "work" but
> would only replace one portability issue with another.
> 
> The new test for AF_LINK && !GNU looks even worse to me.  Does GNU/Hurd
> _really_ define AF_LINK and yet not provide a net/if_dl.h with a
> definition for sockaddr_dl?
> 
> Regards,

Steven,
	As I understood it you wanted the build to fail on Hurd so everyone
would know there was an AF_LINK/sockaddr_dl bug on Hurd. I am not
convinced that that is the right tack to take. I discussed the more
general AF_LINK/sockaddr_dl issue with Pino today, and he's going to
follow up on. But for now I'm just trying to get this package to build
in a sane - if not ideal - way. I'm still open to arguments of course
especially from the maintainer.




Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Wed, 20 Jun 2012 21:54:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Wed, 20 Jun 2012 21:54:08 GMT) Full text and rfc822 format available.

Message #62 received at 675836@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Nicholas Bamber <nicholas@periapt.co.uk>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Wed, 20 Jun 2012 22:50:56 +0100
[Message part 1 (text/plain, inline)]
On 20/06/12 22:09, Nicholas Bamber wrote:
> On 20/06/12 22:04, Steven Chamberlain wrote:
>> This debdiff doesn't address the main point of my original mail:
>> sockaddr_dl and net/if_dl.h are not (k)FreeBSD-specific, so a test for
>> FreeBSD || FreeBSD_kernel would not be appropriate.

You still didn't address that in your reply.

> As I understood it you wanted the build to fail on Hurd so everyone
> would know there was an AF_LINK/sockaddr_dl bug on Hurd.

If there is really an issue in GNU/Hurd, such as a missing header, then
yes, I'd prefer that the build fails[1], rather than add a workaround
(with whatever consequences) to this package (which someone would have
to remember to remove at the appropriate time, to restore the intended
functionality).

As it happens, if a workaround for the current FTBFS is all that's
needed, the attached diff would be able to do that very cleanly.

[1] Just to make sure this isn't the cause of any confusion:  FTBFS on
GNU/Hurd is not a blocker for Wheezy, testing migration or transitions.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org
[sockunion.diff (text/x-patch, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Thu, 21 Jun 2012 08:03:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Thu, 21 Jun 2012 08:03:08 GMT) Full text and rfc822 format available.

Message #67 received at 675836@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: Steven Chamberlain <steven@pyro.eu.org>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Thu, 21 Jun 2012 08:57:38 +0100
On 20/06/12 22:50, Steven Chamberlain wrote:
> You still didn't address that in your reply.
>

Steven,
	You seem to have three issues:

1.) feature based tests rather than platform based tests.
I totally get the desirability of this. It means new OS 's or
improvements to OS's get picked up automatically. My issue was that this
does not work in *this* case. Furthermore I was ignorant of certain
specifics - which is why I was widely circulating the NMU - and so
improperly cautious.
2.) a proper audit trail and making Hurd accountable for the actual issue
Again I totally get this.
3.) You seem to see it fit to willfully cause an FTBS on Hurd, to make a
point.
I don't get that. Any point you might make would be lost in all the
other Hurd FTBS's. Surely it is much better to do something positive.

So I have raised a bug: #678358 to address the underlying issue.
I will clone this bug to a follow up bug blocked by #678358.
I will check the source code of the other packages that I am aware might
have this issue and do the same if I find anything.
I will not delay any more with this NMU and my proposed patch will

* use #if defined(AF_LINK) && !defined(__GNU__) in  both places as that
is as close to a feature check as we can get
* Have a comment explaining the issues in both the code and the patch
header.





Bug 675836 cloned as bug 678375 Request was from Nicholas Bamber <nicholas@periapt.co.uk> to control@bugs.debian.org. (Thu, 21 Jun 2012 09:15:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Thu, 21 Jun 2012 10:16:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Steven Chamberlain <steven@pyro.eu.org>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Thu, 21 Jun 2012 10:16:09 GMT) Full text and rfc822 format available.

Message #74 received at 675836@bugs.debian.org (full text, mbox):

From: Steven Chamberlain <steven@pyro.eu.org>
To: Nicholas Bamber <nicholas@periapt.co.uk>
Cc: Jamie Wilkinson <jaq@debian.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Thu, 21 Jun 2012 11:14:13 +0100
On 21/06/12 08:57, Nicholas Bamber wrote:
> 3.) You seem to see it fit to willfully cause an FTBS on Hurd, to make a
> point.

To willfully allow an existing FTBFS on GNU/Hurd, to become a more
explanatory FTBFS, which would someday go away and keep the intended
functionality once the cause had been resolved in its build-deps.

> So I have raised a bug: #678358 to address the underlying issue.

Yes that was the nice thing to do here, thanks.

> * use #if defined(AF_LINK) && !defined(__GNU__) in  both places as that
> is as close to a feature check as we can get

I'm fine with that, as it would be consistent, and it addresses the most
important point which was the original test for (k)FreeBSD being too
specific.

Regards,
-- 
Steven Chamberlain
steven@pyro.eu.org




Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Thu, 21 Jun 2012 13:21:21 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <sthibault@debian.org>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Thu, 21 Jun 2012 13:21:25 GMT) Full text and rfc822 format available.

Message #79 received at 675836@bugs.debian.org (full text, mbox):

From: Samuel Thibault <sthibault@debian.org>
To: Nicholas Bamber <nicholas@periapt.co.uk>, Jamie Wilkinson <jaq@debian.org>, Steven Chamberlain <steven@pyro.eu.org>, 675836@bugs.debian.org
Cc: debian-hurd@lists.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org
Subject: Re: suggested fix
Date: Thu, 21 Jun 2012 14:22:12 +0200
Nicholas Bamber, le Thu 21 Jun 2012 13:04:17 +0100, a écrit :
> ++/* As per #678358, Hurd defines AF_LINK but does not
> ++ * provide the functionality. When that bug is fixed
> ++ * These three lines could be removed and #678375 closed.
> ++ */
> ++#ifdef __GNU__
> ++#undef AF_LINK
> ++#endif

I'm generally against such kind of hacks, because we then have to
remember where they had been introduced once the actual issue is
resolved, and get yet another upload there instead of a mere buildd
giveback.  I understand that getting "undefined AF_LINK" error message
is clearer to people, but here the maintainers of the package already
understand what the matter is, so they don't actually need the clearer
message.

Btw, the Hurd itself doesn't actually define AF_LINK, it's just that
AF_LINK was added to the generic glibc header instead of system-specific
header. Same for mremap flags which were discussed earlier in another
thread.

Samuel




Information forwarded to debian-bugs-dist@lists.debian.org, Jamie Wilkinson <jaq@debian.org>:
Bug#675836; Package src:pmacct. (Thu, 21 Jun 2012 13:21:28 GMT) Full text and rfc822 format available.

Acknowledgement sent to Nicholas Bamber <nicholas@periapt.co.uk>:
Extra info received and forwarded to list. Copy sent to Jamie Wilkinson <jaq@debian.org>. (Thu, 21 Jun 2012 13:21:34 GMT) Full text and rfc822 format available.

Message #84 received at 675836@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: Jamie Wilkinson <jaq@debian.org>
Cc: Steven Chamberlain <steven@pyro.eu.org>, 675836@bugs.debian.org, "debian-release@lists.debian.org" <debian-release@lists.debian.org>, debian-bsd@lists.debian.org, debian-hurd@lists.debian.org
Subject: Re: suggested fix
Date: Thu, 21 Jun 2012 13:04:17 +0100
[Message part 1 (text/plain, inline)]
On 21/06/12 11:14, Steven Chamberlain wrote:
> On 21/06/12 08:57, Nicholas Bamber wrote:
>> 3.) You seem to see it fit to willfully cause an FTBS on Hurd, to make a
>> point.
> 
> To willfully allow an existing FTBFS on GNU/Hurd, to become a more
> explanatory FTBFS, which would someday go away and keep the intended
> functionality once the cause had been resolved in its build-deps.
> 
>> So I have raised a bug: #678358 to address the underlying issue.
> 
> Yes that was the nice thing to do here, thanks.
> 
>> * use #if defined(AF_LINK) && !defined(__GNU__) in  both places as that
>> is as close to a feature check as we can get
> 
> I'm fine with that, as it would be consistent, and it addresses the most
> important point which was the original test for (k)FreeBSD being too
> specific.
> 
> Regards,

Jamie,
	I have uploaded an NMU with a 2-day delay. The final diff is attached.
Given such a long and protracted discussion I hope you appreciate the
fix and incorporate it into your code as soon as possible. But of course
if you  have an issue with it you can still intervene.
[pmacct.debdiff (text/plain, attachment)]

Added tag(s) patch. Request was from Steven Chamberlain <steven@pyro.eu.org> to control@bugs.debian.org. (Thu, 21 Jun 2012 19:57:07 GMT) Full text and rfc822 format available.

Reply sent to Nicholas Bamber <nicholas@periapt.co.uk>:
You have taken responsibility. (Sat, 23 Jun 2012 12:21:08 GMT) Full text and rfc822 format available.

Notification sent to debian-bsd@lists.debian.org:
Bug acknowledged by developer. (Sat, 23 Jun 2012 12:21:20 GMT) Full text and rfc822 format available.

Message #91 received at 675836-close@bugs.debian.org (full text, mbox):

From: Nicholas Bamber <nicholas@periapt.co.uk>
To: 675836-close@bugs.debian.org
Subject: Bug#675836: fixed in pmacct 0.14.0-1.1
Date: Sat, 23 Jun 2012 12:17:32 +0000
Source: pmacct
Source-Version: 0.14.0-1.1

We believe that the bug you reported is fixed in the latest version of
pmacct, which is due to be installed in the Debian FTP archive:

pmacct_0.14.0-1.1.debian.tar.gz
  to main/p/pmacct/pmacct_0.14.0-1.1.debian.tar.gz
pmacct_0.14.0-1.1.dsc
  to main/p/pmacct/pmacct_0.14.0-1.1.dsc
pmacct_0.14.0-1.1_i386.deb
  to main/p/pmacct/pmacct_0.14.0-1.1_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 675836@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Nicholas Bamber <nicholas@periapt.co.uk> (supplier of updated pmacct package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Thu, 21 Jun 2012 12:39:40 +0100
Source: pmacct
Binary: pmacct
Architecture: source i386
Version: 0.14.0-1.1
Distribution: unstable
Urgency: low
Maintainer: Jamie Wilkinson <jaq@debian.org>
Changed-By: Nicholas Bamber <nicholas@periapt.co.uk>
Description: 
 pmacct     - promiscuous mode traffic accountant
Closes: 675836
Changes: 
 pmacct (0.14.0-1.1) unstable; urgency=low
 .
   * Non-maintainer upload.
   * Added patch to handle AF_LINK on hurd and kfreebsd
     platforms (Closes: #675836)
Checksums-Sha1: 
 9932fa6e6c9c15fd9df4877c5487415275edeec6 1769 pmacct_0.14.0-1.1.dsc
 9d9011dae9ba72420dc4c7af2edf2aa568e0cfe9 11532 pmacct_0.14.0-1.1.debian.tar.gz
 13913798d52bd8e156c9ee05c78d759e7f403086 1373722 pmacct_0.14.0-1.1_i386.deb
Checksums-Sha256: 
 89ebb1abda145e25edad5b97b055c30936b741e700f41f209bd4369697dfe536 1769 pmacct_0.14.0-1.1.dsc
 ca188101b3dab0ba911d2302738dc4754a5eadee90708d2af72b6aa1a39d0a11 11532 pmacct_0.14.0-1.1.debian.tar.gz
 8672cd2c6c386b4f22ca4ceff27f36a890f608d5ce608b01927851b4672cba0d 1373722 pmacct_0.14.0-1.1_i386.deb
Files: 
 e0047e8db852f49374c2bdb00c9d76f0 1769 net optional pmacct_0.14.0-1.1.dsc
 72a284002ffedf49de0a060273d86f7d 11532 net optional pmacct_0.14.0-1.1.debian.tar.gz
 ee750560a9d9a2b7ec626a648218d26a 1373722 net optional pmacct_0.14.0-1.1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJP4wqGAAoJELbE2bY7/+c8RS0QAJRIGZFdDBof00rIzyIqppZt
AgYDMHy+nEGDYcU5w5WY2B63QG056J/vfmbpWfzmnjP6kpj2zRbagmKO5baIaL0y
BcE0uQx6eq5WsmNqagam6XFGCPW3i0rJx9E/rNzaa+pX00kh/56oNSMS3K/WJm/l
P+OikrIZRbxI9Yd21Uf5g1qNy86QgIOGa41M/cFUN2j4Kfcn8QUQk/KM8YdwAVi9
xntw4Ci65219TB8e/+WNfumK5RY+N2rT/qVu6gNRqZlkmQOBJZJHSGmIeqxDfGPA
KqzIdhl07TCY8aOBlA4HmFzPS0uYII8h1venDXCJwgFOwEsHSUhU+TxvBFyh3zbf
1lVnrE+X/WZ5IdSthQEWDceOF3G6owhgwb36HIRlKsKLdD0g2LUeCzPyovz8GQRk
VPTXGxvO0T3VFyu5QWJynJgLsmcRLjqUaM3LaEup7GFXQJr+ismBm03Sn6ILTbzV
DheKbwlaUqbibrROKzJki4AebcHosDQuFuJ0bTfP/GjYz5Wra4zzID9xCc7QKeWA
ING3Df2hX7LIK8amHzn7t9dm0Xb8D9EzIlnaExjpLLAa6ZIdVLqDrMsqEppk5W/V
Bba4iFIaKTuiCN4cg3po6Lb9o6uyUX/R/UrvvE/tOH9xBvOw+i8FZZNuZjfdpNcp
HV4eM0M876lEmmWgLHer
=QU0g
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 23 Jul 2012 07:31:09 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 16:17:04 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.